org.cpsolver.ifs.solution

## Interface SolutionListener<V extends Variable<V,T>,T extends Value<V,T>>

- Type Parameters:
    `V` - Variable
    `T` - Value
  All Known Implementing Classes:
    ExamGreatDeluge, ExamHillClimbing, ExamSimulatedAnnealing, GreatDeluge, GreatDeluge.GreatDelugeContext, HillClimber, HillClimber.HillClimberContext, MaxIdleNeighbourSelection, NeighbourSearch, NeighbourSearch.NeighbourSearchContext, ParallelConstruction, PotentialHardConflicts, SearchIntensification, SimulatedAnnealing, SimulatedAnnealing.SimulatedAnnealingContext, StepCountingHillClimber, StepCountingHillClimber.StepCountingHillClimberContext, Test, Test.TestSolutionListener, WeightedHardConflicts

      public interface SolutionListener<V extends Variable<V,T>,T extends Value<V,T>>

  IFS solution listener.
  Version:
    IFS 1.3 (Iterative Forward Search)
    Copyright (C) 2006 - 2014 Tomáš Müller
    muller@unitime.org
    http://muller.unitime.org
    This library is free software; you can redistribute it and/or modify it under the terms of the GNU Lesser General Public License as published by the Free Software Foundation; either version 3 of the License, or (at your option) any later version.
    This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.
    You should have received a copy of the GNU Lesser General Public License along with this library; if not see http://www.gnu.org/licenses/.
  Author:
    Tomáš Müller
  See Also:
    `Solution`

- - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `bestCleared(Solution<V,T> solution)` Called by the solution when method `Solution.clearBest()` is called.
    `void` | `bestRestored(Solution<V,T> solution)` Called by the solution when method `Solution.restoreBest()` is called.
    `void` | `bestSaved(Solution<V,T> solution)` Called by the solution when method `Solution.saveBest()` is called.
    `void` | `getInfo(Solution<V,T> solution, Map<String,String> info)` Called by the solution when it is asked to produce info table, see `Solution.getInfo()`.
    `void` | `getInfo(Solution<V,T> solution, Map<String,String> info, Collection<V> variables)` Called by the solution when it is asked to produce info table, see `Solution.getInfo()`.
    `void` | `solutionUpdated(Solution<V,T> solution)` Called by the solution when it is updated, see `Solution.update(double)`.

- - ### Method Detail

    - #### solutionUpdated

          void solutionUpdated(Solution<V,T> solution)

      Called by the solution when it is updated, see `Solution.update(double)`.
      Parameters:
        `solution` - source solution

    - #### getInfo

          void getInfo(Solution<V,T> solution,
                       Map<String,String> info)

      Called by the solution when it is asked to produce info table, see `Solution.getInfo()`. A listener can also add some its info into this table.
      Parameters:
        `solution` - source solution
        `info` - produced info table

    - #### getInfo

          void getInfo(Solution<V,T> solution,
                       Map<String,String> info,
                       Collection<V> variables)

      Called by the solution when it is asked to produce info table, see `Solution.getInfo()`. A listener can also add some its info into this table.
      Parameters:
        `solution` - source solution
        `info` - produced info table
        `variables` - only variables from this set are included

    - #### bestCleared

          void bestCleared(Solution<V,T> solution)

      Called by the solution when method `Solution.clearBest()` is called.
      Parameters:
        `solution` - source solution

    - #### bestSaved

          void bestSaved(Solution<V,T> solution)

      Called by the solution when method `Solution.saveBest()` is called.
      Parameters:
        `solution` - source solution

    - #### bestRestored

          void bestRestored(Solution<V,T> solution)

      Called by the solution when method `Solution.restoreBest()` is called.
      Parameters:
        `solution` - source solution